#!/bin/sh
VMLINUXSZ=$(stat -c%s vmlinux.64)
echo vmlinux filesize $VMLINUXSZ

VMLINUXMULT=$(( $VMLINUXSZ >> 17 ))
let VMLINUXMULT++
VMLINUXADD=$(( 160 - $VMLINUXMULT ))
VMLINUXMULT=$(( $VMLINUXMULT << 17 ))
VMLINUXREM=$(( $VMLINUXMULT - $VMLINUXSZ ))
VMLINUXMULT=$(( $VMLINUXMULT >> 17 ))

echo bytes to make it 128K multiple $VMLINUXREM + $VMLINUXADD \*128K 


rm -f xff128K.img
echo | tr '\012' '\377' >> xff128K.img
let i=0

while [ $i -lt 17 ] ; do
  cat xff128K.img xff128K.img > xff.img
  mv -f xff.img xff128K.img
  let i++
done

XFF=$(stat -c%s xff128K.img)
echo filesize $XFF

echo copy remaining at end
cp -f vmlinux.64 wms5316_flash.img
dd if=xff128K.img bs=1  of=wms5316_flash.img seek=$VMLINUXSZ count=$VMLINUXREM

let i=$VMLINUXMULT

while [ $i -lt 160 ] ; do
  dd if=xff128K.img bs=128K of=wms5316_flash.img seek=$i count=1
  let i++
done

echo Appending appimage - make it a multiple of 128K

RDISKSZ=$(stat -c%s wncramdisk.bin)
echo wncramdisk filesize $RDISKSZ
RDISKMULT=$(( $RDISKSZ >> 17 ))
let RDISKMULT++
RDISKADD=$(( 80 - $RDISKMULT ))
RDISKMULT=$(( $RDISKMULT << 17 ))
RDISKREM=$(( $RDISKMULT - $RDISKSZ ))
RDISKMULT=$(( $RDISKMULT >> 17 ))

echo bytes to make it 128K multiple $RDISKREM + $RDISKADD \*128K 
cp wncramdisk.bin wncramdisk.flash.img
dd if=xff128K.img bs=1 of=wncramdisk.flash.img seek=$RDISKSZ count=$RDISKREM

dd if=wncramdisk.flash.img bs=128K of=wms5316_flash.img seek=160 count=$RDISKMULT

let i=160+$RDISKMULT

echo $(stat -c%s wms5316_flash.img)

while [ $i -lt 240 ] ; do
  dd if=xff128K.img bs=128K of=wms5316_flash.img seek=$i count=1
  let i++
done

dd if=wncramdisk.flash.img bs=128K of=wms5316_flash.img seek=240 count=$RDISKMULT

rm -f xff128K.img wncramdisk.flash.img

